// global coding here!

var nsIPrefServiceObj = {};
nsIPrefServiceObj = Components.classes["@mozilla.org/preferences-service;1"]
                                   .getService(Components.interfaces.nsIPrefService);
var nsIPrefBranchObj = nsIPrefServiceObj.getBranch(null);

// ==================================================================================

function getBrowserWin(){
 return window._content;
}

function getFocusedFrameWin(){
 return document.commandDispatcher.focusedWindow;
}

function getBrowserDoc(){
 return window._content.document;
}

function getFocusedFrameDoc(){
 return document.commandDispatcher.focusedWindow.document;
}

//=========================================================================================
function getWinInfo(win){
//=========================================================================================
// Main function to build page with all requested data
//=========================================================================================

try{

//=========================================================================================
// Get documentor settings
//=========================================================================================

var intNumberOfImageProperties = 8;

// Boolean settings
var prefblnShowLinks = nsIPrefBranchObj.getBoolPref("documenter.ShowLinks");
var prefblnShowForms = nsIPrefBranchObj.getBoolPref("documenter.ShowForms");
var prefblnShowCode = nsIPrefBranchObj.getBoolPref("documenter.ShowCode");
var prefblnShowLists = nsIPrefBranchObj.getBoolPref("documenter.ShowOptionLists");
var prefblnLimitLists = nsIPrefBranchObj.getBoolPref("documenter.LimitOptionLists");
var prefblnShowImages = nsIPrefBranchObj.getBoolPref("documenter.ShowImages");
var prefblnShowCookies = nsIPrefBranchObj.getBoolPref("documenter.ShowCookies");
var prefblnShowStyles = nsIPrefBranchObj.getBoolPref("documenter.ShowStylesBlock");
var prefblnShowImageDupes = nsIPrefBranchObj.getBoolPref("documenter.ShowImageDuplicates");
var prefblnAngentInfo = nsIPrefBranchObj.getBoolPref("documenter.AgentInfo");
var prefblnReferrerInfo = nsIPrefBranchObj.getBoolPref("documenter.ReferrerInfo");
var prefblnPathInfo = nsIPrefBranchObj.getBoolPref("documenter.PathInfo");
var prefblnHostInfo = nsIPrefBranchObj.getBoolPref("documenter.HostInfo");
var prefblnLastMod = nsIPrefBranchObj.getBoolPref("documenter.LastMod");
var prefblnIncludeUserName = nsIPrefBranchObj.getBoolPref("documenter.IncludeUserName");
var prefblnDontAskForTitle = nsIPrefBranchObj.getBoolPref("documenter.DontAskForTitle");
var prefblnUseHiddenColors = nsIPrefBranchObj.getBoolPref("documenter.UseHiddenColors");
var prefblnShowQueryStrings = nsIPrefBranchObj.getBoolPref("documenter.ShowQueryStrings");

// Character settings
var prefstrUserName = nsIPrefBranchObj.getCharPref("documenter.UserName");
var prefstrTitleColor = nsIPrefBranchObj.getCharPref("documenter.TitleColor");
var prefstrHiddenColor = nsIPrefBranchObj.getCharPref("documenter.HiddenColor");
var prefstrDefaultReportTitle = nsIPrefBranchObj.getCharPref("documenter.DefaultReportTitle");
var prefstrOptionListMax = nsIPrefBranchObj.getCharPref("documenter.OptionListMax");

var SpecialTags = new Array();
var SpecialCheck = new Array();
var ImageProp = new Array();
var ImagePropValue = new Array();
var Property=[];
var i;
for (i = 1; i < 6; i++)
{
	SpecialTags[i] = nsIPrefBranchObj.getCharPref("documenter.SpecTag" + i.toString());
	SpecialCheck[i] = nsIPrefBranchObj.getBoolPref("documenter.SpecCheck" + i.toString());
}
for (i = 1; i < 12; i++)
{
	Property.push = nsIPrefBranchObj.getBoolPref("documenter.Prop" + i.toString());
}
// Image Properties
var TempValue;
var x = new Array();
var intImageProp = 0;
for (var ii = 1; ii < intNumberOfImageProperties; ii++)
{
	intImageProp = intImageProp + 1;
	if (nsIPrefBranchObj.getCharPref("documenter.ImagePropValue" + ii.toString()).indexOf('/') > 0)
	{
	    ImageProp[intImageProp] = nsIPrefBranchObj.getBoolPref("documenter.ImageProp" + ii.toString());
	    ImageProp[intImageProp+1] = nsIPrefBranchObj.getBoolPref("documenter.ImageProp" + ii.toString());
		x = nsIPrefBranchObj.getCharPref("documenter.ImagePropValue" + ii.toString()).split('/');
		ImagePropValue[intImageProp] = x[0];
		intImageProp = intImageProp + 1;
		ImagePropValue[intImageProp] = x[1];
	}
	else
	{
		ImagePropValue[intImageProp] = nsIPrefBranchObj.getCharPref("documenter.ImagePropValue" + ii.toString());
	    ImageProp[intImageProp] = nsIPrefBranchObj.getBoolPref("documenter.ImageProp" + ii.toString());
	}
}

//=========================================================================================
// Other Initialization
//=========================================================================================
if (prefstrOptionListMax == 0)
{
	prefstrOptionListMax = 20;
}
var a=[];

//=========================================================================================
// Heading of Report
//=========================================================================================

 a.push('<HTML><BODY>'); 
if (!prefblnDontAskForTitle)
{
    var Problem
	Problem = prompt('Please enter the title for the report');
	if (Problem.length > 0)
	{
		a.push('<p align="center"><h2>' + Problem + '</h2></p>');
	}
	else
	{
		a.push('<p align="center"><h2>' + prefstrDefaultReportTitle + '</h2></p>');
	}
}
else
{
     a.push('<p align="center"><h2>' + prefstrDefaultReportTitle + '</h2></p>');
}

 a.push('Location : ' + win.location + '<BR>'); 
if (prefblnHostInfo) {a.push('Host: ' + win._content.location.host + '<BR>');}
if (prefblnAngentInfo) {a.push('User Agent: ' + navigator.userAgent + '<BR>');}
if (prefblnPathInfo) {a.push('Path name: ' + win._content.location.pathname + '<BR>');}
 a.push('Name : ' + win.name + '<BR>');
if (prefblnIncludeUserName) {a.push('User&rsquo;s Name : ' + prefstrUserName + '<BR>');}

 var doc=win.document;
 if(doc) {
    var strAttrName
   a.push('Title : ' + doc.title  + '<BR>'); 
if (prefblnReferrerInfo) {a.push('Referrer : ' + doc.referrer + '<BR>');}
if (prefblnLastMod) {a.push('LastModified : ' + doc.lastModified + '<BR>');}
   Today = new Date();
   a.push('Information as of: ' + Today.toLocaleString() + '<BR>');


//=========================================================================================
// Scripts
//=========================================================================================

   var NumberOfScripts = doc.getElementsByTagName('script').length;
   if ((NumberOfScripts > 0) && prefblnShowCode)
   {
	a.push('<BR/><TABLE border="3"><TR><TD align="center" bgcolor="' + prefstrTitleColor + '"><H3>Script Blocks</H3></TD></TR>');
   var strTheScript = '';
   for (var ScriptCounter = 0; ScriptCounter < NumberOfScripts; ScriptCounter ++)
   {
        strTheScript = window._content.document.getElementsByTagName('script').item(ScriptCounter).innerHTML;
		if (strTheScript.length > 5)
		{
        	strTheScript = strTheScript.replace(/<!--/, ' ').replace(/</, '&lt;').split('\n').join('<br/>').replace(/\/\/ -->/, ' ').replace(/-->/, ' ').replace(/\>[ ]+\</,'><').replace(/<br\/><br\/><br\/>/, '<br/><br/>');
        	a.push('<TR><TD>' + strTheScript + '</td></tr>');
		}
   }
   a.push('</TABLE><P/>');
   }

//=========================================================================================
// Styles
//=========================================================================================

   if ((doc.styleSheets.length > 0) && prefblnShowStyles)
   {
   a.push('<BR/><TABLE border="3"><TR><TD align="center" bgcolor="' + prefstrTitleColor + '"><H3>STYLES</H3></TD></TR>');
   for (var StyleCounter = 0; StyleCounter < doc.styleSheets.length; StyleCounter++)
   {
      if (doc.styleSheets[StyleCounter].href)
      {
         a.push('<tr><td bgcolor="cyan"><h3>From file: ' + doc.styleSheets[StyleCounter].href + '</TD></tr>');
      }
      else
      {
         a.push('<tr><td bgcolor="cyan"><h3>Styles Within This Page</TD></tr>');
      }
      for (var StyleCounter2 = 0; StyleCounter2 < doc.styleSheets[StyleCounter].cssRules.length; StyleCounter2++)
      {
         a.push('<TR><TD>' + doc.styleSheets[StyleCounter].cssRules[StyleCounter2].cssText + '</TD></tr>');
      }
   }
   a.push('</TABLE><P/>');
   }

//=========================================================================================
// Cookies
//=========================================================================================

   if (doc.cookie && prefblnShowCookies)
   {
   a.push('<BR/><TABLE border="3"><TR><TD align="center" bgcolor="' + prefstrTitleColor + '"><H3>COOKIES</H3></TD></TR>');
   a.push('<TR><TD>' + doc.cookie.split(';').join('</TD></TR><TR><TD>'));
   a.push('</TD></TR></TABLE>');
   }

//=========================================================================================
// Links
//=========================================================================================

   if (doc.links.length && prefblnShowLinks)
   {
   a.push('<BR><TABLE border="3"><TR><TD colspan="3" align="center" bgcolor="' + prefstrTitleColor + '"><H3>LINKS</H3></TD></TR>');
   if (prefblnShowQueryStrings)
	{
		a.push('<TR><TH>Text</TH><TH>Link</TH><TH>Query String</TH></TR>');
	}
	else
	{
		a.push('<TR><TH>Text</TH><TH>Link</TH></TR>');
	}
   for (var LinkCounter = 0; LinkCounter < doc.links.length; LinkCounter++)
   {
      a.push('<TR><TD>' + doc.links[LinkCounter].text + '</TD><TD>');
      if ((doc.links[LinkCounter].href.indexOf("?") > 0) && (prefblnShowQueryStrings))
      {
        a.push(doc.links[LinkCounter].href.substring(0,doc.links[LinkCounter].href.indexOf("?")) + '</TD><TD>' + doc.links[LinkCounter].href.substring(doc.links[LinkCounter].href.indexOf("?")+1) + '</TD></TR>');
      }
      else
      {
		if (prefblnShowQueryStrings)
		{
			a.push(doc.links[LinkCounter].href + '</TD><TD>' + '&nbsp;</TD></TR>');
		}
		else
		{
			a.push(doc.links[LinkCounter].href.substring(0,doc.links[LinkCounter].href.indexOf("?")) + '</TD></TR>');
		}
      }
   }
   a.push('</TABLE><P/>');
   }
   else
   {
   a.push('<BR>Links: ' + (doc.links.length?doc.links.length:'none') + '<BR>');
   }

//=========================================================================================
// Images
//=========================================================================================

   if (doc.images.length && prefblnShowImages)
   {
   var ImageArray = new Array();
   var ImageCount = 1;
   a.push('<BR><TABLE border="3"><TR><TD colspan="' + ImagePropValue.length + '" align="center" bgcolor="' + prefstrTitleColor + '"><H3>IMAGES</H3></TD></TR><tr>');
// <TH>Source</TH> <TH>Alt</TH> <TH>Title</TH></TR>');
	for (var ImgAPropCounter = 1; ImgAPropCounter < ImagePropValue.length; ImgAPropCounter++)
	{
		if (ImageProp[ImgAPropCounter])
		{
			a.push('<th>' + ImagePropValue[ImgAPropCounter] + '</th>');
		}
	}
	a.push('</tr>');
   for (var ImageCounter = 0; ImageCounter < doc.images.length; ImageCounter++)
   {
      if (! (ExistingValue(ImageArray, doc.images[ImageCounter].src)) || prefblnShowImageDupes)
      {
// Old Code
//         ImageArray[ImageCount] = doc.images[ImageCounter].src;
//         ImageCount ++;
//         a.push('<TR><TD>' + doc.images[ImageCounter].src + '</TD><TD>');
//         if(doc.images[ImageCounter].alt)
//         {
//           a.push(doc.images[ImageCounter].alt + '</TD><TD>');
//         }
//         else
//         {
//           a.push('&nbsp;</TD><TD>');
//         }
//         if(doc.images[ImageCounter].title)
//         {
//           a.push(doc.images[ImageCounter].title + '</TD></TR>');
//         }
//         else
//         {
//           a.push('&nbsp;</TD></TR>');
//         }

// New Code

		ImageArray[ImageCount] = doc.images[ImageCounter].src;
		ImageCount ++;
		a.push('<tr>');
		for (var ImgPropCounter = 1; ImgPropCounter < ImagePropValue.length; ImgPropCounter++)
		{
			if(ImageProp[ImgPropCounter])
			{
				if(eval('doc.images[ImageCounter].' + ImagePropValue[ImgPropCounter]))
				{
					a.push('<td>' + eval('doc.images[ImageCounter].' + ImagePropValue[ImgPropCounter]) + '</td>');
				}
				else
				{
					a.push('<td>&nbsp;</td>');
				}
			}
		}
		a.push('</tr>');


      }
   }
   a.push('</TABLE><P/>');
   }
   else
   {
   a.push('Images: ' + (doc.images.length?doc.images.length:'none') + '<BR/>');
   }

//=========================================================================================

   if (! prefblnShowForms) {a.push('Forms: ' + (doc.forms.length?doc.forms.length:'none') + '<BR/>');}

//=========================================================================================

//   if (doc.forms.length && prefblnShowForms)
   for (var LoopCounter = 0; LoopCounter < doc.forms.length; LoopCounter++)
   {
      a.push('<BR><TABLE border="3"><TR><TD colspan="5" align="center" bgcolor="' + prefstrTitleColor + '"><H3>Form - ' + doc.forms[LoopCounter].name + '</H3></TD></TR><TR><TH>#</TH><TH>Name</TH><TH align="center">Type</TH><TH>Value</TH><TH>Other</TH></TR>');
      for (var LoopCounter2 = 0; LoopCounter2 < doc.forms[LoopCounter].elements.length; LoopCounter2++)
      {
      a.push('<TR><TD>' + LoopCounter2 + '</TD><TD>' + doc.forms[LoopCounter].elements[LoopCounter2].name + '</TD>'); 
      if (doc.forms[LoopCounter].elements[LoopCounter2].type == 'hidden' && prefblnUseHiddenColors)
      {
      a.push('<TD align="center" bgcolor="' + prefstrHiddenColor + '">' + doc.forms[LoopCounter].elements[LoopCounter2].type + '</TD>'); 
       }
      else
       {
      a.push('<TD align="center">' + doc.forms[LoopCounter].elements[LoopCounter2].type + '</TD>'); 
      }
      if (doc.forms[LoopCounter].elements[LoopCounter2].value.length == 0)
         {
              a.push('<TD>&nbsp;</TD><TD>');
          }
          else
          {
              a.push('<TD>' + doc.forms[LoopCounter].elements[LoopCounter2].value + '</TD><TD>');
          }

//=========================================================================================
// To find the type, use type instead of name.
// Using the switch command to show appropriate data based on the element type.    
//=========================================================================================

      switch (doc.forms[LoopCounter].elements[LoopCounter2].type)
         {

          case "text":
               if (typeof(doc.forms[LoopCounter].elements[LoopCounter2].width) != "undefined")
               {
//                  a.push('&nbsp; with a width of: ' + doc.forms[LoopCounter].elements[LoopCounter2].width + '<BR>');
               }
//		Cycle through attributes for any code!
               if (prefblnShowCode)
               {
	          for (var AttrCounter = 0; AttrCounter < doc.forms[LoopCounter].elements[LoopCounter2].attributes.length; AttrCounter++)
                  {
//                     a.push(' attrib # ' + AttrCounter + ' => ' + doc.forms[LoopCounter].elements[LoopCounter2].attributes[AttrCounter].name + ' = ');
                     strAttrName = doc.forms[LoopCounter].elements[LoopCounter2].attributes[AttrCounter].name
//                     if (doc.forms[LoopCounter].elements[LoopCounter2].attributes[AttrCounter].name.substring(0,2) == "on")
                     if (strAttrName.substring(0,2) == "on")
                     {
                        a.push('|  ' + strAttrName + ' ="');
                        a.push(doc.forms[LoopCounter].elements[LoopCounter2].attributes[AttrCounter].value + '" ');
                     }
                     if (strAttrName == "class")
                     {
                        a.push('| Class ="');
                        a.push(doc.forms[LoopCounter].elements[LoopCounter2].attributes[AttrCounter].value + '" ');
                     }
                  }
               }
               break;

          case "textarea":
               if (typeof(doc.forms[LoopCounter].elements[LoopCounter2].cols) != "undefined")
               {
                  a.push('# of cols: ' + doc.forms[LoopCounter].elements[LoopCounter2].cols);
                }
               if (typeof(doc.forms[LoopCounter].elements[LoopCounter2].rows) != "undefined")
               {
                     if (typeof(doc.forms[LoopCounter].elements[LoopCounter2].cols) != "undefined")
                    {
                       a.push('<BR>');
                     }
                 a.push('     # of rows: ' + doc.forms[LoopCounter].elements[LoopCounter2].rows);
                }
                break;

          case "hidden":
                break;

          case "select-one":
                if (prefblnShowLists && doc.forms[LoopCounter].elements[LoopCounter2].options.length < prefstrOptionListMax)
                {
                   a.push(DisplayOptionList(doc.forms[LoopCounter].elements[LoopCounter2]));
                }
		else
		{
		   a.push(doc.forms[LoopCounter].elements[LoopCounter2].options.length + ' options are listed.');
		}
                if (prefblnShowCode)
                {
//		  Cycle through attributes for any code!
	          for (var AttrCounter = 0; AttrCounter < doc.forms[LoopCounter].elements[LoopCounter2].attributes.length; AttrCounter++)
                  {
                     if (doc.forms[LoopCounter].elements[LoopCounter2].attributes[AttrCounter].name.substring(0,2) == "on")
                     {
                        a.push('|  ' + doc.forms[LoopCounter].elements[LoopCounter2].attributes[AttrCounter].name + '="');
                        a.push(doc.forms[LoopCounter].elements[LoopCounter2].attributes[AttrCounter].value + '" ');
                     }
                  }
                }
                break;

          case "checkbox":
               if (doc.forms[LoopCounter].elements[LoopCounter2].checked)
               {
                  a.push('  Is Checked  ');
                }
                else
                {
                  a.push('  Is Not Checked  ');
                 }
               if (doc.forms[LoopCounter].elements[LoopCounter2].disabled)
               {
                  a.push('<I>  Is Disabled </I> ');
                }
                if (prefblnShowCode)
                {
//		  Cycle through attributes for any code!
	          for (var AttrCounter = 0; AttrCounter < doc.forms[LoopCounter].elements[LoopCounter2].attributes.length; AttrCounter++)
                  {
                     if (doc.forms[LoopCounter].elements[LoopCounter2].attributes[AttrCounter].name.substring(0,2) == "on")
                     {
                        a.push('|  ' + doc.forms[LoopCounter].elements[LoopCounter2].attributes[AttrCounter].name + '="');
                        a.push(doc.forms[LoopCounter].elements[LoopCounter2].attributes[AttrCounter].value + '" ');
                     }
                  }
                }
                break;
          }    // End of switch block
//=========================================================================================

         a.push('&nbsp;</TD></TR>');
      }    // End of loop of elements
      a.push('</TABLE>');
   }    // End of Forms loop
//=========================================================================================

//=========================================================================================
// Special Tags
//=========================================================================================

	var NumberOfSpecialTags = SpecialTags.length;
	var SpecialInnerText;
//a.push('The number of special tags is: ' + NumberOfSpecialTags + '<br/>');
	for (var SpecialCounter = 1; SpecialCounter < (NumberOfSpecialTags + 1); SpecialCounter ++)
	{
		if (SpecialCheck[SpecialCounter] && (SpecialTags[SpecialCounter].length > 1))
		{
//alert('loop1');
			a.push('<BR/><TABLE border="3"><TR><TD align="center" bgcolor="' + prefstrTitleColor + '"><H3>' + SpecialTags[SpecialCounter] + '</H3></TD></TR>');
			if (doc.getElementsByTagName(SpecialTags[SpecialCounter]).length == 0)
			{
				a.push('<TR><TD>This tag was not found in the page.</td></tr>');
			}
			else
			{
				for (var SpecialCounter2 = 0; SpecialCounter2 < doc.getElementsByTagName(SpecialTags[SpecialCounter]).length; SpecialCounter2 ++)
				{
//alert('loop2');
			        SpecialInnerText = doc.getElementsByTagName(SpecialTags[SpecialCounter]).item(SpecialCounter2).innerHTML;
    	    		SpecialInnerText = SpecialInnerText.replace(/<!--/, ' ').replace(/</, '&lt;').split('\n').join('<br/>').replace(/\/\/ -->/, ' ').replace(/-->/, ' ').replace(/\>[ ]+\</,'><').replace(/<br\/><br\/><br\/>/, '<br/><br/>');
        			a.push('<TR><TD>' + SpecialInnerText + '</td></tr>');
				}
			}
			a.push('</TABLE><P/>');
		}
   }
//=========================================================================================


 }    // End of "if(doc)"
 a.push('Status : ' + win.status + '<BR>'); 
 a.push('Sub Frames : ' + (win.frames.length?win.frames.length:'none') + '<BR>');
 return a.join('');

}    // End of try{

catch(error)
{
alert('The following error occurred:\n' + error);
}
 
}

function getHiddenInfo(win){
 var a=[];
 a.push('Location : ' + win.location + '\n'); 
 a.push('Name : ' + win.name + '\n'); 

 var doc=win.document;
 if(doc) {
   a.push('Title : ' + doc.title  + '\n'); 
   for (var LoopCounter = 0; LoopCounter < doc.forms.length; LoopCounter++)
   {
      for (var LoopCounter2 = 0; LoopCounter2 < doc.forms[LoopCounter].elements.length; LoopCounter2++)
      {
      if (doc.forms[LoopCounter].elements[LoopCounter2].type == 'hidden')
      {
      a.push('Field Name: ' + doc.forms[LoopCounter].elements[LoopCounter2].name + '   ====VALUE===>  ' + doc.forms[LoopCounter].elements[LoopCounter2].value + '\n');
      }
      }
   }
 }
 return a.join(''); 
}

function OutputInformation(){

var mainwin = getBrowserWin();
var s;
s=getWinInfo(mainwin);

var new_window = window.open();
new_window._content.document.writeln(s);
new_window._content.document.writeln('\n</BODY></HTML>');
new_window._content.document.close();
}


function ViewHiddenFields(){

var mainwin = getBrowserWin();
var s;
s=getHiddenInfo(mainwin);

alert('HIDDEN INFO\n\n'+s);

}


function DisplayOptionList(OptList)
{
var OutString
   OutString = '<table border="2"><tr><td colspan="2" align="center" bgcolor="silver"><b>OPTIONS</b></td></tr>';
   OutString = OutString + '<tr><td><b>Value</b></td><td><b>Text<b></td></tr>';
   for (var OptionCounter = 0; OptionCounter < OptList.options.length; OptionCounter ++)
   {
      OutString = OutString + '<tr><td>' + OptList.options[OptionCounter].value + '</td><td>';
      OutString = OutString + OptList.options[OptionCounter].text + '</td></tr>';
   }
   OutString = OutString + '</table>';
   return OutString;
}

function ExistingValue(ImageArray, ValueToCheck)
{
var ValueFound = false;
for (i = 0; i < ImageArray.length; i++)
{
if (ImageArray[i] == ValueToCheck)
{
ValueFound  = true;
break;
}
}
return ValueFound;
}
